/*
 * ocfs2_err.c:
 * This file is automatically generated; please do not edit it.
 */

#include <stdlib.h>

static const char * const text[] = {
		"Device name specified was not found",
		"Illegal or malformed device name",
		"I/O error on channel",
		"Attempt to read block from filesystem resulted in short read",
		"Attempt to read block from filesystem resulted in short write",
		"Memory allocation failed",
		"Invalid argument passed to OCFS2 library",
		"Device contains an OCFS volume",
		"Bad magic number in superblock",
		"Filesystem has unexpected block size",
		"The OCFS2 superblock is corrupt",
		"Unsupported feature(s) found",
		"Unsupported read-only feature(s) found",
		"Bad magic number in inode",
		"Invalid block number",
		"Attempt to write to filesystem opened read-only",
		"Journal must be at least 1024 blocks",
		"Bad magic number in journal superblock",
		"Invalid revoke record in journal",
		"Invalid block tag in journal",
		"Inode is not valid (active)",
		"Inode type does not contain extents",
		"Bad magic number in extent block",
		"Extent block is corrupt",
		"OCFS2 directory corrupted",
		"OCFS2 inode is not a directory",
		"File not found by ocfs2_lookup",
		"No free space in the directory",
		"Bit does not exist in bitmap range",
		"Internal logic faliure",
		"Bad magic number in group descriptor",
		"Group descriptor is corrupt",
		"Chain allocator is corrupt",
		"Invalid range passed to extent map lookup",
		"No mapping exists for the given extent range",
		"Duplicate block discovered",
		"Unable to find available bit",
		"Attempting to free unallocated region",
		"Unable to expand directory",
		"No space available",
		"Iteration complete",
		"Too many symbolic links encountered",
		"Invalid heartbeat file",
		"Unknown filesystem",
		"The block size is smaller than the sector size on this device",
		"The lock name is invalid",
		"Can't find ionice",
		"Backup superblock not found",
    0
};

struct error_table {
    char const * const * msgs;
    long base;
    int n_msgs;
};
struct et_list {
    struct et_list *next;
    const struct error_table * table;
};
extern struct et_list *_et_list;

const struct error_table et_ocfs_error_table = { text, -1512559360L, 48 };

static struct et_list link = { 0, 0 };

void initialize_ocfs_error_table_r(struct et_list **list);
void initialize_ocfs_error_table(void);

void initialize_ocfs_error_table(void) {
    initialize_ocfs_error_table_r(&_et_list);
}

/* For Heimdal compatibility */
void initialize_ocfs_error_table_r(struct et_list **list)
{
    struct et_list *et, **end;

    for (end = list, et = *list; et; end = &et->next, et = et->next)
        if (et->table->msgs == text)
            return;
    et = malloc(sizeof(struct et_list));
    if (et == 0) {
        if (!link.table)
            et = &link;
        else
            return;
    }
    et->table = &et_ocfs_error_table;
    et->next = 0;
    *end = et;
}
